Index: drivers/filesystems/btrfs/create.c
===================================================================
--- drivers/filesystems/btrfs/create.c	(révision 75772)
+++ drivers/filesystems/btrfs/create.c	(copie de travail)
@@ -2247,174 +2090,225 @@
     fcb->subvol = parfileref->fcb->subvol;
     fcb->inode = parfileref->fcb->inode;
     fcb->type = parfileref->fcb->type;
-    
+
     fcb->ads = TRUE;
-    
+
     Status = RtlUnicodeToUTF8N(NULL, 0, &utf8len, stream->Buffer, stream->Length);
     if (!NT_SUCCESS(Status)) {
         ERR("RtlUnicodeToUTF8N 1 returned %08x\n", Status);
-        free_fcb(fcb);
+        free_fcb(Vcb, fcb);
         return Status;
     }
-    
-    fcb->adsxattr.Length = utf8len + xapreflen;
+
+    fcb->adsxattr.Length = (UINT16)utf8len + xapreflen;
     fcb->adsxattr.MaximumLength = fcb->adsxattr.Length + 1;
     fcb->adsxattr.Buffer = ExAllocatePoolWithTag(pool_type, fcb->adsxattr.MaximumLength, ALLOC_TAG);
     if (!fcb->adsxattr.Buffer) {
         ERR("out of memory\n");
-        free_fcb(fcb);
+        free_fcb(Vcb, fcb);
         return STATUS_INSUFFICIENT_RESOURCES;
     }
-    
+
     RtlCopyMemory(fcb->adsxattr.Buffer, xapref, xapreflen);
-    
+
     Status = RtlUnicodeToUTF8N(&fcb->adsxattr.Buffer[xapreflen], utf8len, &utf8len, stream->Buffer, stream->Length);
     if (!NT_SUCCESS(Status)) {
         ERR("RtlUnicodeToUTF8N 2 returned %08x\n", Status);
-        free_fcb(fcb);
+        free_fcb(Vcb, fcb);
         return Status;
     }
-    
+
     fcb->adsxattr.Buffer[fcb->adsxattr.Length] = 0;
-    
+
     TRACE("adsxattr = %s\n", fcb->adsxattr.Buffer);
-    
+
     fcb->adshash = calc_crc32c(0xfffffffe, (UINT8*)fcb->adsxattr.Buffer, fcb->adsxattr.Length);
     TRACE("adshash = %08x\n", fcb->adshash);
-    
+
     searchkey.obj_id = parfileref->fcb->inode;
     searchkey.obj_type = TYPE_XATTR_ITEM;
     searchkey.offset = fcb->adshash;
-    
+
     Status = find_item(Vcb, parfileref->fcb->subvol, &tp, &searchkey, FALSE, Irp);
     if (!NT_SUCCESS(Status)) {
         ERR("find_item returned %08x\n", Status);
-        free_fcb(fcb);
+        free_fcb(Vcb, fcb);
         return Status;
     }
-    
+
     if (!keycmp(tp.item->key, searchkey))
         overhead = tp.item->size;
     else
         overhead = 0;
-    
+
     fcb->adsmaxlen = Vcb->superblock.node_size - sizeof(tree_header) - sizeof(leaf_node) - (sizeof(DIR_ITEM) - 1);
-    
+
     if (utf8len + xapreflen + overhead > fcb->adsmaxlen) {
         WARN("not enough room for new DIR_ITEM (%u + %u > %u)", utf8len + xapreflen, overhead, fcb->adsmaxlen);
-        free_fcb(fcb);
+        free_fcb(Vcb, fcb);
         return STATUS_DISK_FULL;
     } else
         fcb->adsmaxlen -= overhead + utf8len + xapreflen;
-    
-    fileref = create_fileref();
+
+    fileref = create_fileref(Vcb);
     if (!fileref) {
         ERR("out of memory\n");
-        free_fcb(fcb);
+        free_fcb(Vcb, fcb);
         return STATUS_INSUFFICIENT_RESOURCES;
     }
-    
+
     fileref->fcb = fcb;
 
-    fileref->filepart.MaximumLength = fileref->filepart.Length = stream->Length;
-    fileref->filepart.Buffer = ExAllocatePoolWithTag(pool_type, fileref->filepart.MaximumLength, ALLOC_TAG);
-    if (!fileref->filepart.Buffer) {
+    dc = ExAllocatePoolWithTag(PagedPool, sizeof(dir_child), ALLOC_TAG);
+    if (!dc) {
         ERR("out of memory\n");
-        free_fileref(fileref);
+        free_fileref(Vcb, fileref);
         return STATUS_INSUFFICIENT_RESOURCES;
     }
-    
-    RtlCopyMemory(fileref->filepart.Buffer, stream->Buffer, stream->Length);
-    
-    Status = RtlUpcaseUnicodeString(&fileref->filepart_uc, &fileref->filepart, TRUE);
+
+    RtlZeroMemory(dc, sizeof(dir_child));
+
+    dc->utf8.MaximumLength = dc->utf8.Length = fcb->adsxattr.Length - xapreflen;
+    dc->utf8.Buffer = ExAllocatePoolWithTag(PagedPool, dc->utf8.MaximumLength, ALLOC_TAG);
+    if (!dc->utf8.Buffer) {
+        ERR("out of memory\n");
+        ExFreePool(dc);
+        free_fileref(Vcb, fileref);
+        return STATUS_INSUFFICIENT_RESOURCES;
+    }
+
+    RtlCopyMemory(dc->utf8.Buffer, &fcb->adsxattr.Buffer[xapreflen], fcb->adsxattr.Length - xapreflen);
+
+    dc->name.MaximumLength = dc->name.Length = stream->Length;
+    dc->name.Buffer = ExAllocatePoolWithTag(pool_type, dc->name.MaximumLength, ALLOC_TAG);
+    if (!dc->name.Buffer) {
+        ERR("out of memory\n");
+        ExFreePool(dc->utf8.Buffer);
+        ExFreePool(dc);
+        free_fileref(Vcb, fileref);
+        return STATUS_INSUFFICIENT_RESOURCES;
+    }
+
+    RtlCopyMemory(dc->name.Buffer, stream->Buffer, stream->Length);
+
+    Status = RtlUpcaseUnicodeString(&dc->name_uc, &dc->name, TRUE);
     if (!NT_SUCCESS(Status)) {
         ERR("RtlUpcaseUnicodeString returned %08x\n", Status);
-        free_fileref(fileref);
+        ExFreePool(dc->utf8.Buffer);
+        ExFreePool(dc->name.Buffer);
+        ExFreePool(dc);
+        free_fileref(Vcb, fileref);
         return Status;
     }
-    
+
+    dc->fileref = fileref;
+    fileref->dc = dc;
+
+    InsertHeadList(&parfileref->fcb->dir_children_index, &dc->list_entry_index);
+
     mark_fcb_dirty(fcb);
     mark_fileref_dirty(fileref);
-    
+
     InsertHeadList(&parfileref->fcb->list_entry, &fcb->list_entry); // insert in list after parent fcb
     InsertTailList(&Vcb->all_fcbs, &fcb->list_entry_all);
-    
+
     KeQuerySystemTime(&time);
     win_time_to_unix(time, &now);
-    
+
     parfileref->fcb->inode_item.transid = Vcb->superblock.generation;
     parfileref->fcb->inode_item.sequence++;
     parfileref->fcb->inode_item.st_ctime = now;
     parfileref->fcb->inode_item_changed = TRUE;
-    
+
     mark_fcb_dirty(parfileref->fcb);
-    
+
     parfileref->fcb->subvol->root_item.ctransid = Vcb->superblock.generation;
     parfileref->fcb->subvol->root_item.ctime = now;
-    
+
     fileref->parent = (struct _file_ref*)parfileref;
-    
-    insert_fileref_child(parfileref, fileref, TRUE);
-    
+
+    ExAcquireResourceExclusiveLite(&parfileref->nonpaged->children_lock, TRUE);
+    InsertTailList(&parfileref->children, &fileref->list_entry);
+    ExReleaseResourceLite(&parfileref->nonpaged->children_lock);
+
     increase_fileref_refcount(parfileref);
-    
+
     *pfileref = fileref;
-    
+
+    send_notification_fileref(parfileref, options & FILE_DIRECTORY_FILE ? FILE_NOTIFY_CHANGE_DIR_NAME : FILE_NOTIFY_CHANGE_FILE_NAME, FILE_ACTION_ADDED, &fileref->dc->name);
+
     return STATUS_SUCCESS;
 }
 
-static NTSTATUS STDCALL file_create(PIRP Irp, device_extension* Vcb, PFILE_OBJECT FileObject, file_ref* related, BOOL loaded_related,
-                                    PUNICODE_STRING fnus, ULONG disposition, ULONG options, LIST_ENTRY* rollback) {
+// LXSS programs can be distinguished by the fact they have a NULL PEB.
+#ifdef _AMD64_
+static __inline BOOL called_from_lxss() {
     NTSTATUS Status;
-//     fcb *fcb, *parfcb = NULL;
+    PROCESS_BASIC_INFORMATION pbi;
+    ULONG retlen;
+
+    Status = ZwQueryInformationProcess(NtCurrentProcess(), ProcessBasicInformation, &pbi, sizeof(pbi), &retlen);
+
+    if (!NT_SUCCESS(Status)) {
+        ERR("ZwQueryInformationProcess returned %08x\n", Status);
+        return FALSE;
+    }
+
+    return !pbi.PebBaseAddress;
+}
+#else
+#define called_from_lxss() FALSE
+#endif
+
+static NTSTATUS file_create(PIRP Irp, _Requires_lock_held_(_Curr_->tree_lock) _Requires_exclusive_lock_held_(_Curr_->fcb_lock) device_extension* Vcb,
+                            PFILE_OBJECT FileObject, file_ref* related, BOOL loaded_related, PUNICODE_STRING fnus, ULONG disposition, ULONG options, LIST_ENTRY* rollback) {
+    NTSTATUS Status;
     file_ref *fileref, *parfileref = NULL;
-    ULONG i, j, fn_offset;
-//     ULONG utf8len;
+    ULONG i, j;
     ccb* ccb;
     static WCHAR datasuf[] = {':','$','D','A','T','A',0};
     UNICODE_STRING dsus, fpus, stream;
     PIO_STACK_LOCATION IrpSp = IoGetCurrentIrpStackLocation(Irp);
     POOL_TYPE pool_type = IrpSp->Flags & SL_OPEN_PAGING_FILE ? NonPagedPool : PagedPool;
-    PACCESS_STATE access_state = IrpSp->Parameters.Create.SecurityContext->AccessState;
 #ifdef DEBUG_FCB_REFCOUNTS
     LONG oc;
 #endif
 
     TRACE("(%p, %p, %p, %.*S, %x, %x)\n", Irp, Vcb, FileObject, fnus->Length / sizeof(WCHAR), fnus->Buffer, disposition, options);
-    
+
     if (Vcb->readonly)
         return STATUS_MEDIA_WRITE_PROTECTED;
-    
+
     dsus.Buffer = datasuf;
-    dsus.Length = dsus.MaximumLength = wcslen(datasuf) * sizeof(WCHAR);
+    dsus.Length = dsus.MaximumLength = (USHORT)wcslen(datasuf) * sizeof(WCHAR);
     fpus.Buffer = NULL;
-    
+
     if (!loaded_related) {
         Status = open_fileref(Vcb, &parfileref, fnus, related, TRUE, NULL, NULL, pool_type, IrpSp->Flags & SL_CASE_SENSITIVE, Irp);
-        
+
         if (!NT_SUCCESS(Status))
             goto end;
     } else
         parfileref = related;
-    
+
     if (parfileref->fcb->type != BTRFS_TYPE_DIRECTORY && (fnus->Length < sizeof(WCHAR) || fnus->Buffer[0] != ':')) {
         Status = STATUS_OBJECT_PATH_NOT_FOUND;
         goto end;
     }
-    
-    if (parfileref->fcb->subvol->root_item.flags & BTRFS_SUBVOL_READONLY) {
+
+    if (is_subvol_readonly(parfileref->fcb->subvol, Irp)) {
         Status = STATUS_ACCESS_DENIED;
         goto end;
     }
-    
+
     i = (fnus->Length / sizeof(WCHAR))-1;
     while ((fnus->Buffer[i] == '\\' || fnus->Buffer[i] == '/') && i > 0) { i--; }
-    
+
     j = i;
-    
+
     while (i > 0 && fnus->Buffer[i-1] != '\\' && fnus->Buffer[i-1] != '/') { i--; }
-    
-    fpus.MaximumLength = (j - i + 2) * sizeof(WCHAR);
+
+    fpus.MaximumLength = (USHORT)((j - i + 2) * sizeof(WCHAR));
     fpus.Buffer = ExAllocatePoolWithTag(pool_type, fpus.MaximumLength, ALLOC_TAG);
     if (!fpus.Buffer) {
         ERR("out of memory\n");
@@ -2421,46 +2315,44 @@
         Status = STATUS_INSUFFICIENT_RESOURCES;
         goto end;
     }
-    
-    fpus.Length = (j - i + 1) * sizeof(WCHAR);
-    
+
+    fpus.Length = (USHORT)((j - i + 1) * sizeof(WCHAR));
+
     RtlCopyMemory(fpus.Buffer, &fnus->Buffer[i], (j - i + 1) * sizeof(WCHAR));
     fpus.Buffer[j - i + 1] = 0;
-    
-    fn_offset = i;
-    
+
     if (fpus.Length > dsus.Length) { // check for :$DATA suffix
         UNICODE_STRING lb;
-                
+
         lb.Buffer = &fpus.Buffer[(fpus.Length - dsus.Length)/sizeof(WCHAR)];
         lb.Length = lb.MaximumLength = dsus.Length;
-        
+
         TRACE("lb = %.*S\n", lb.Length/sizeof(WCHAR), lb.Buffer);
-        
+
         if (FsRtlAreNamesEqual(&dsus, &lb, TRUE, NULL)) {
             TRACE("ignoring :$DATA suffix\n");
-            
+
             fpus.Length -= lb.Length;
-            
+
             if (fpus.Length > sizeof(WCHAR) && fpus.Buffer[(fpus.Length-1)/sizeof(WCHAR)] == ':')
                 fpus.Length -= sizeof(WCHAR);
-            
+
             TRACE("fpus = %.*S\n", fpus.Length / sizeof(WCHAR), fpus.Buffer);
         }
     }
-    
+
     stream.Length = 0;
-    
-    for (i = 0; i < fpus.Length/sizeof(WCHAR); i++) {
+
+    for (i = 0; i < fpus.Length / sizeof(WCHAR); i++) {
         if (fpus.Buffer[i] == ':') {
-            stream.Length = fpus.Length - (i*sizeof(WCHAR)) - sizeof(WCHAR);
+            stream.Length = (USHORT)(fpus.Length - (i * sizeof(WCHAR)) - sizeof(WCHAR));
             stream.Buffer = &fpus.Buffer[i+1];
             fpus.Buffer[i] = 0;
-            fpus.Length = i * sizeof(WCHAR);
+            fpus.Length = (USHORT)(i * sizeof(WCHAR));
             break;
         }
     }
-    
+
     if (stream.Length > 0) {
         Status = create_stream(Vcb, &fileref, &parfileref, &fpus, &stream, Irp, options, pool_type, IrpSp->Flags & SL_CASE_SENSITIVE, rollback);
         if (!NT_SUCCESS(Status)) {
@@ -2467,15 +2359,32 @@
             ERR("create_stream returned %08x\n", Status);
             goto end;
         }
+
+        IoSetShareAccess(IrpSp->Parameters.Create.SecurityContext->DesiredAccess, IrpSp->Parameters.Create.ShareAccess,
+                         FileObject, &fileref->fcb->share_access);
     } else {
-        if (!is_file_name_valid(&fpus)) {
+        ACCESS_MASK granted_access;
+
+        if (!is_file_name_valid(&fpus, FALSE)) {
             Status = STATUS_OBJECT_NAME_INVALID;
             goto end;
         }
-        
+
+        SeLockSubjectContext(&IrpSp->Parameters.Create.SecurityContext->AccessState->SubjectSecurityContext);
+
+        if (!SeAccessCheck(parfileref->fcb->sd, &IrpSp->Parameters.Create.SecurityContext->AccessState->SubjectSecurityContext,
+                           TRUE, options & FILE_DIRECTORY_FILE ? FILE_ADD_SUBDIRECTORY : FILE_ADD_FILE, 0, NULL,
+                           IoGetFileObjectGenericMapping(), IrpSp->Flags & SL_FORCE_ACCESS_CHECK ? UserMode : Irp->RequestorMode,
+                           &granted_access, &Status)) {
+            SeUnlockSubjectContext(&IrpSp->Parameters.Create.SecurityContext->AccessState->SubjectSecurityContext);
+            goto end;
+        }
+
+        SeUnlockSubjectContext(&IrpSp->Parameters.Create.SecurityContext->AccessState->SubjectSecurityContext);
+
         if (Irp->AssociatedIrp.SystemBuffer && IrpSp->Parameters.Create.EaLength > 0) {
             ULONG offset;
-            
+
             Status = IoCheckEaBufferValidity(Irp->AssociatedIrp.SystemBuffer, IrpSp->Parameters.Create.EaLength, &offset);
             if (!NT_SUCCESS(Status)) {
                 ERR("IoCheckEaBufferValidity returned %08x (error at offset %u)\n", Status, offset);
@@ -2482,35 +2391,37 @@
                 goto end;
             }
         }
-        
+
         Status = file_create2(Irp, Vcb, &fpus, parfileref, options, Irp->AssociatedIrp.SystemBuffer, IrpSp->Parameters.Create.EaLength,
                               &fileref, rollback);
-        
+
         if (!NT_SUCCESS(Status)) {
             ERR("file_create2 returned %08x\n", Status);
             goto end;
         }
-        
-        send_notification_fileref(fileref, options & FILE_DIRECTORY_FILE ? FILE_NOTIFY_CHANGE_DIR_NAME : FILE_NOTIFY_CHANGE_FILE_NAME, FILE_ACTION_ADDED);
-        send_notification_fcb(fileref->parent, FILE_NOTIFY_CHANGE_LAST_WRITE, FILE_ACTION_MODIFIED);
+
+        IoSetShareAccess(IrpSp->Parameters.Create.SecurityContext->DesiredAccess, IrpSp->Parameters.Create.ShareAccess, FileObject, &fileref->fcb->share_access);
+
+        send_notification_fileref(fileref, options & FILE_DIRECTORY_FILE ? FILE_NOTIFY_CHANGE_DIR_NAME : FILE_NOTIFY_CHANGE_FILE_NAME, FILE_ACTION_ADDED, NULL);
+        send_notification_fcb(fileref->parent, FILE_NOTIFY_CHANGE_LAST_WRITE, FILE_ACTION_MODIFIED, NULL);
     }
-    
+
     FileObject->FsContext = fileref->fcb;
-    
+
     ccb = ExAllocatePoolWithTag(NonPagedPool, sizeof(*ccb), ALLOC_TAG);
     if (!ccb) {
         ERR("out of memory\n");
         Status = STATUS_INSUFFICIENT_RESOURCES;
-        free_fileref(fileref);
+        free_fileref(Vcb, fileref);
         goto end;
     }
-    
+
     RtlZeroMemory(ccb, sizeof(*ccb));
-    
+
     ccb->fileref = fileref;
-    
+
     ccb->NodeType = BTRFS_NODE_TYPE_CCB;
-    ccb->NodeSize = sizeof(ccb);
+    ccb->NodeSize = sizeof(*ccb);
     ccb->disposition = disposition;
     ccb->options = options;
     ccb->query_dir_offset = 0;
@@ -2517,9 +2428,11 @@
     RtlInitUnicodeString(&ccb->query_string, NULL);
     ccb->has_wildcard = FALSE;
     ccb->specific_file = FALSE;
-    ccb->access = access_state->OriginalDesiredAccess;
+    ccb->access = IrpSp->Parameters.Create.SecurityContext->DesiredAccess;
     ccb->case_sensitive = IrpSp->Flags & SL_CASE_SENSITIVE;
-    
+    ccb->reserving = FALSE;
+    ccb->lxss = called_from_lxss();
+
 #ifdef DEBUG_FCB_REFCOUNTS
     oc = InterlockedIncrement(&fileref->open_count);
     ERR("fileref %p: open_count now %i\n", fileref, oc);
@@ -2527,52 +2440,21 @@
     InterlockedIncrement(&fileref->open_count);
 #endif
     InterlockedIncrement(&Vcb->open_files);
-    
+
     FileObject->FsContext2 = ccb;
-    
-    if (fn_offset > 0) {
-        FileObject->FileName.Length -= fn_offset * sizeof(WCHAR);
-        RtlMoveMemory(&FileObject->FileName.Buffer[0], &FileObject->FileName.Buffer[fn_offset], FileObject->FileName.Length);
-    }
 
     FileObject->SectionObjectPointer = &fileref->fcb->nonpaged->segment_object;
-    
-//     TRACE("returning FCB %p with parent %p\n", fcb, parfcb);
-    
-//     ULONG fnlen;
-// 
-//     fcb->name_offset = fcb->par->full_filename.Length / sizeof(WCHAR);
-//             
-//     if (fcb->par != Vcb->root_fcb)
-//         fcb->name_offset++;
-//     
-//     fnlen = (fcb->name_offset * sizeof(WCHAR)) + fcb->filepart.Length;
-//     
-//     fcb->full_filename.Buffer = ExAllocatePoolWithTag(PagedPool, fnlen, ALLOC_TAG);
-//     if (!fcb->full_filename.Buffer) {
-//         ERR("out of memory\n");
-//         Status = STATUS_INSUFFICIENT_RESOURCES;
-//         goto end;
-//     }   
-//     
-//     fcb->full_filename.Length = fcb->full_filename.MaximumLength = fnlen;
-//     RtlCopyMemory(fcb->full_filename.Buffer, fcb->par->full_filename.Buffer, fcb->par->full_filename.Length);
-//     
-//     if (fcb->par != Vcb->root_fcb)
-//         fcb->full_filename.Buffer[fcb->par->full_filename.Length / sizeof(WCHAR)] = '\\';
-//     
-//     RtlCopyMemory(&fcb->full_filename.Buffer[fcb->name_offset], fcb->filepart.Buffer, fcb->filepart.Length);
-        
+
     goto end2;
-    
-end:    
+
+end:
     if (fpus.Buffer)
         ExFreePool(fpus.Buffer);
-    
+
 end2:
     if (parfileref && !loaded_related)
-        free_fileref(parfileref);
-    
+        free_fileref(Vcb, parfileref);
+
     return Status;
 }
 
@@ -2579,9 +2461,9 @@
 static __inline void debug_create_options(ULONG RequestedOptions) {
     if (RequestedOptions != 0) {
         ULONG options = RequestedOptions;
-        
+
         TRACE("requested options:\n");
-        
+
         if (options & FILE_DIRECTORY_FILE) {
             TRACE("    FILE_DIRECTORY_FILE\n");
             options &= ~FILE_DIRECTORY_FILE;
@@ -2631,7 +2513,7 @@
             TRACE("    FILE_NO_EA_KNOWLEDGE\n");
             options &= ~FILE_NO_EA_KNOWLEDGE;
         }
-        
+
         if (options & FILE_OPEN_REMOTE_INSTANCE) {
             TRACE("    FILE_OPEN_REMOTE_INSTANCE\n");
             options &= ~FILE_OPEN_REMOTE_INSTANCE;
@@ -2656,7 +2538,7 @@
             TRACE("    FILE_OPEN_FOR_BACKUP_INTENT\n");
             options &= ~FILE_OPEN_FOR_BACKUP_INTENT;
         }
-        
+
         if (options & FILE_NO_COMPRESSION) {
             TRACE("    FILE_NO_COMPRESSION\n");
             options &= ~FILE_NO_COMPRESSION;
@@ -2667,7 +2549,7 @@
             TRACE("    FILE_OPEN_REQUIRING_OPLOCK\n");
             options &= ~FILE_OPEN_REQUIRING_OPLOCK;
         }
-        
+
         if (options & FILE_DISALLOW_EXCLUSIVE) {
             TRACE("    FILE_DISALLOW_EXCLUSIVE\n");
             options &= ~FILE_DISALLOW_EXCLUSIVE;
@@ -2683,17 +2565,17 @@
             TRACE("    FILE_OPEN_REPARSE_POINT\n");
             options &= ~FILE_OPEN_REPARSE_POINT;
         }
-        
+
         if (options & FILE_OPEN_NO_RECALL) {
             TRACE("    FILE_OPEN_NO_RECALL\n");
             options &= ~FILE_OPEN_NO_RECALL;
         }
-        
+
         if (options & FILE_OPEN_FOR_FREE_SPACE_QUERY) {
             TRACE("    FILE_OPEN_FOR_FREE_SPACE_QUERY\n");
             options &= ~FILE_OPEN_FOR_FREE_SPACE_QUERY;
         }
-        
+
         if (options)
             TRACE("    unknown options: %x\n", options);
     } else {
@@ -2703,35 +2585,39 @@
 
 static NTSTATUS get_reparse_block(fcb* fcb, UINT8** data) {
     NTSTATUS Status;
-    
+
     if (fcb->type == BTRFS_TYPE_FILE || fcb->type == BTRFS_TYPE_SYMLINK) {
         ULONG size, bytes_read, i;
-        
+
         if (fcb->type == BTRFS_TYPE_FILE && fcb->inode_item.st_size < sizeof(ULONG)) {
             WARN("file was too short to be a reparse point\n");
             return STATUS_INVALID_PARAMETER;
         }
-        
+
         // 0x10007 = 0xffff (maximum length of data buffer) + 8 bytes header
-        size = min(0x10007, fcb->inode_item.st_size);
-        
+        size = (ULONG)min(0x10007, fcb->inode_item.st_size);
+
+        if (size == 0)
+            return STATUS_INVALID_PARAMETER;
+
         *data = ExAllocatePoolWithTag(PagedPool, size, ALLOC_TAG);
         if (!*data) {
             ERR("out of memory\n");
             return STATUS_INSUFFICIENT_RESOURCES;
         }
-        
-        Status = read_file(fcb, *data, 0, size, &bytes_read, NULL, TRUE);
+
+        Status = read_file(fcb, *data, 0, size, &bytes_read, NULL);
         if (!NT_SUCCESS(Status)) {
             ERR("read_file_fcb returned %08x\n", Status);
             ExFreePool(*data);
             return Status;
         }
-        
+
         if (fcb->type == BTRFS_TYPE_SYMLINK) {
-            ULONG stringlen, subnamelen, printnamelen, reqlen;
+            ULONG stringlen, reqlen;
+            UINT16 subnamelen, printnamelen;
             REPARSE_DATA_BUFFER* rdb;
-            
+
             Status = RtlUTF8ToUnicodeN(NULL, 0, &stringlen, (char*)*data, bytes_read);
             if (!NT_SUCCESS(Status)) {
                 ERR("RtlUTF8ToUnicodeN 1 returned %08x\n", Status);
@@ -2738,30 +2624,29 @@
                 ExFreePool(*data);
                 return Status;
             }
-            
-            subnamelen = stringlen;
-            printnamelen = stringlen;
-            
+
+            subnamelen = printnamelen = (USHORT)stringlen;
+
             reqlen = offsetof(REPARSE_DATA_BUFFER, SymbolicLinkReparseBuffer.PathBuffer) + subnamelen + printnamelen;
-            
+
             rdb = ExAllocatePoolWithTag(PagedPool, reqlen, ALLOC_TAG);
-            
+
             if (!rdb) {
                 ERR("out of memory\n");
                 ExFreePool(*data);
                 return STATUS_INSUFFICIENT_RESOURCES;
             }
-            
+
             rdb->ReparseTag = IO_REPARSE_TAG_SYMLINK;
-            rdb->ReparseDataLength = reqlen - offsetof(REPARSE_DATA_BUFFER, SymbolicLinkReparseBuffer);
+            rdb->ReparseDataLength = (USHORT)(reqlen - offsetof(REPARSE_DATA_BUFFER, SymbolicLinkReparseBuffer));
             rdb->Reserved = 0;
-            
+
             rdb->SymbolicLinkReparseBuffer.SubstituteNameOffset = 0;
             rdb->SymbolicLinkReparseBuffer.SubstituteNameLength = subnamelen;
             rdb->SymbolicLinkReparseBuffer.PrintNameOffset = subnamelen;
             rdb->SymbolicLinkReparseBuffer.PrintNameLength = printnamelen;
             rdb->SymbolicLinkReparseBuffer.Flags = SYMLINK_FLAG_RELATIVE;
-            
+
             Status = RtlUTF8ToUnicodeN(&rdb->SymbolicLinkReparseBuffer.PathBuffer[rdb->SymbolicLinkReparseBuffer.SubstituteNameOffset / sizeof(WCHAR)],
                                     stringlen, &stringlen, (char*)*data, size);
 
@@ -2771,18 +2656,18 @@
                 ExFreePool(*data);
                 return Status;
             }
-            
+
             for (i = 0; i < stringlen / sizeof(WCHAR); i++) {
                 if (rdb->SymbolicLinkReparseBuffer.PathBuffer[(rdb->SymbolicLinkReparseBuffer.SubstituteNameOffset / sizeof(WCHAR)) + i] == '/')
                     rdb->SymbolicLinkReparseBuffer.PathBuffer[(rdb->SymbolicLinkReparseBuffer.SubstituteNameOffset / sizeof(WCHAR)) + i] = '\\';
             }
-            
+
             RtlCopyMemory(&rdb->SymbolicLinkReparseBuffer.PathBuffer[rdb->SymbolicLinkReparseBuffer.PrintNameOffset / sizeof(WCHAR)],
                         &rdb->SymbolicLinkReparseBuffer.PathBuffer[rdb->SymbolicLinkReparseBuffer.SubstituteNameOffset / sizeof(WCHAR)],
                         rdb->SymbolicLinkReparseBuffer.SubstituteNameLength);
-            
+
             ExFreePool(*data);
-            
+
             *data = (UINT8*)rdb;
         } else {
             Status = FsRtlValidateReparsePointBuffer(bytes_read, (REPARSE_DATA_BUFFER*)*data);
@@ -2795,42 +2680,82 @@
     } else if (fcb->type == BTRFS_TYPE_DIRECTORY) {
         if (!fcb->reparse_xattr.Buffer || fcb->reparse_xattr.Length == 0)
             return STATUS_INTERNAL_ERROR;
-            
+
         if (fcb->reparse_xattr.Length < sizeof(ULONG)) {
             WARN("xattr was too short to be a reparse point\n");
             return STATUS_INTERNAL_ERROR;
         }
-        
+
         Status = FsRtlValidateReparsePointBuffer(fcb->reparse_xattr.Length, (REPARSE_DATA_BUFFER*)fcb->reparse_xattr.Buffer);
         if (!NT_SUCCESS(Status)) {
             ERR("FsRtlValidateReparsePointBuffer returned %08x\n", Status);
             return Status;
         }
-        
+
         *data = ExAllocatePoolWithTag(PagedPool, fcb->reparse_xattr.Length, ALLOC_TAG);
         if (!*data) {
             ERR("out of memory\n");
             return STATUS_INSUFFICIENT_RESOURCES;
         }
-        
+
         RtlCopyMemory(*data, fcb->reparse_xattr.Buffer, fcb->reparse_xattr.Length);
     }
-    
+
     return STATUS_SUCCESS;
 }
 
-static NTSTATUS STDCALL open_file(PDEVICE_OBJECT DeviceObject, PIRP Irp, LIST_ENTRY* rollback) {
-    PFILE_OBJECT FileObject;
+static void fcb_load_csums(_Requires_lock_held_(_Curr_->tree_lock) device_extension* Vcb, fcb* fcb, PIRP Irp) {
+    LIST_ENTRY* le;
+    NTSTATUS Status;
+
+    if (fcb->csum_loaded)
+        return;
+
+    if (IsListEmpty(&fcb->extents) || fcb->inode_item.flags & BTRFS_INODE_NODATASUM)
+        goto end;
+
+    le = fcb->extents.Flink;
+    while (le != &fcb->extents) {
+        extent* ext = CONTAINING_RECORD(le, extent, list_entry);
+
+        if (ext->extent_data.type == EXTENT_TYPE_REGULAR) {
+            EXTENT_DATA2* ed2 = (EXTENT_DATA2*)&ext->extent_data.data[0];
+            UINT64 len;
+
+            len = (ext->extent_data.compression == BTRFS_COMPRESSION_NONE ? ed2->num_bytes : ed2->size) / Vcb->superblock.sector_size;
+
+            ext->csum = ExAllocatePoolWithTag(NonPagedPool, (ULONG)(len * sizeof(UINT32)), ALLOC_TAG);
+            if (!ext->csum) {
+                ERR("out of memory\n");
+                goto end;
+            }
+
+            Status = load_csum(Vcb, ext->csum, ed2->address + (ext->extent_data.compression == BTRFS_COMPRESSION_NONE ? ed2->offset : 0), len, Irp);
+
+            if (!NT_SUCCESS(Status)) {
+                ERR("load_csum returned %08x\n", Status);
+                goto end;
+            }
+        }
+
+        le = le->Flink;
+    }
+
+end:
+    fcb->csum_loaded = TRUE;
+}
+
+static NTSTATUS open_file(PDEVICE_OBJECT DeviceObject, _Requires_lock_held_(_Curr_->tree_lock) device_extension* Vcb, PIRP Irp, LIST_ENTRY* rollback) {
+    PFILE_OBJECT FileObject = NULL;
     ULONG RequestedDisposition;
     ULONG options;
     NTSTATUS Status;
     ccb* ccb;
-    device_extension* Vcb = DeviceObject->DeviceExtension;
-    PIO_STACK_LOCATION Stack = IoGetCurrentIrpStackLocation(Irp);
+    PIO_STACK_LOCATION IrpSp = IoGetCurrentIrpStackLocation(Irp);
     USHORT parsed;
     ULONG fn_offset = 0;
-    file_ref *related, *fileref;
-    POOL_TYPE pool_type = Stack->Flags & SL_OPEN_PAGING_FILE ? NonPagedPool : PagedPool;
+    file_ref *related, *fileref = NULL;
+    POOL_TYPE pool_type = IrpSp->Flags & SL_OPEN_PAGING_FILE ? NonPagedPool : PagedPool;
     ACCESS_MASK granted_access;
     BOOL loaded_related = FALSE;
     UNICODE_STRING fn;
@@ -2840,90 +2765,88 @@
 #ifdef DEBUG_STATS
     LARGE_INTEGER time1, time2;
     UINT8 open_type = 0;
-    
+
     time1 = KeQueryPerformanceCounter(NULL);
 #endif
-    
+
     Irp->IoStatus.Information = 0;
-    
-    RequestedDisposition = ((Stack->Parameters.Create.Options >> 24) & 0xff);
-    options = Stack->Parameters.Create.Options & FILE_VALID_OPTION_FLAGS;
-    
+
+    RequestedDisposition = ((IrpSp->Parameters.Create.Options >> 24) & 0xff);
+    options = IrpSp->Parameters.Create.Options & FILE_VALID_OPTION_FLAGS;
+
     if (options & FILE_DIRECTORY_FILE && RequestedDisposition == FILE_SUPERSEDE) {
         WARN("error - supersede requested with FILE_DIRECTORY_FILE\n");
-        Status = STATUS_INVALID_PARAMETER;
-        goto exit2;
+        return STATUS_INVALID_PARAMETER;
     }
 
-    FileObject = Stack->FileObject;
-    
+    FileObject = IrpSp->FileObject;
+
+    if (!FileObject) {
+        ERR("FileObject was NULL\n");
+        return STATUS_INVALID_PARAMETER;
+    }
+
     if (FileObject->RelatedFileObject && FileObject->RelatedFileObject->FsContext2) {
         struct _ccb* relatedccb = FileObject->RelatedFileObject->FsContext2;
-        
+
         related = relatedccb->fileref;
     } else
         related = NULL;
-    
+
     debug_create_options(options);
-    
+
     switch (RequestedDisposition) {
         case FILE_SUPERSEDE:
             TRACE("requested disposition: FILE_SUPERSEDE\n");
             break;
-            
+
         case FILE_CREATE:
             TRACE("requested disposition: FILE_CREATE\n");
             break;
-            
+
         case FILE_OPEN:
             TRACE("requested disposition: FILE_OPEN\n");
             break;
-            
+
         case FILE_OPEN_IF:
             TRACE("requested disposition: FILE_OPEN_IF\n");
             break;
-            
+
         case FILE_OVERWRITE:
             TRACE("requested disposition: FILE_OVERWRITE\n");
             break;
-            
+
         case FILE_OVERWRITE_IF:
             TRACE("requested disposition: FILE_OVERWRITE_IF\n");
             break;
-            
+
         default:
             ERR("unknown disposition: %x\n", RequestedDisposition);
             Status = STATUS_NOT_IMPLEMENTED;
             goto exit;
     }
-    
+
     fn = FileObject->FileName;
-    
+
     TRACE("(%.*S)\n", fn.Length / sizeof(WCHAR), fn.Buffer);
     TRACE("FileObject = %p\n", FileObject);
-    
+
     if (Vcb->readonly && (RequestedDisposition == FILE_SUPERSEDE || RequestedDisposition == FILE_CREATE || RequestedDisposition == FILE_OVERWRITE)) {
         Status = STATUS_MEDIA_WRITE_PROTECTED;
-        goto exit2;
+        goto exit;
     }
-    
-    if (Vcb->readonly && Stack->Parameters.Create.SecurityContext->DesiredAccess &
-        (FILE_WRITE_DATA | FILE_APPEND_DATA | FILE_WRITE_EA | FILE_WRITE_ATTRIBUTES | DELETE | WRITE_OWNER | WRITE_DAC)) {
-        Status = STATUS_MEDIA_WRITE_PROTECTED;
-        goto exit2;
-    }
-    
+
     ExAcquireResourceExclusiveLite(&Vcb->fcb_lock, TRUE);
 
     if (options & FILE_OPEN_BY_FILE_ID) {
         if (fn.Length == sizeof(UINT64) && related && RequestedDisposition == FILE_OPEN) {
             UINT64 inode;
-            
+
             RtlCopyMemory(&inode, fn.Buffer, sizeof(UINT64));
-            
+
             if (related->fcb == Vcb->root_fileref->fcb && inode == 0)
                 inode = Vcb->root_fileref->fcb->inode;
-            
+
             if (inode == 0) { // we use 0 to mean the parent of a subvolume
                 fileref = related->parent;
                 increase_fileref_refcount(fileref);
